"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VersionBlock = VersionBlock;
const documenter_ui_heading_1 = require("@teambit/documenter.ui.heading");
const design_ui_contributors_1 = require("@teambit/design.ui.contributors");
const base_react_navigation_link_1 = require("@teambit/base-react.navigation.link");
const component_ui_version_label_1 = require("@teambit/component.ui.version-label");
const classnames_1 = __importDefault(require("classnames"));
const react_1 = __importStar(require("react"));
const design_ui_tooltip_1 = require("@teambit/design.ui.tooltip");
const lanes_hooks_use_lanes_1 = require("@teambit/lanes.hooks.use-lanes");
const lanes_ui_models_lanes_model_1 = require("@teambit/lanes.ui.models.lanes-model");
const version_block_module_scss_1 = __importDefault(require("./version-block.module.scss"));
// @todo - this will be fixed as part of the @teambit/base-react.navigation.link upgrade to latest
const Link = base_react_navigation_link_1.Link;
/**
 * change log section
 * @name VersionBlock
 */
function VersionBlock(_a) {
    var { isLatest, className, snap, componentId, isCurrent } = _a, rest = __rest(_a, ["isLatest", "className", "snap", "componentId", "isCurrent"]);
    const { username, email, message, tag, hash, date } = snap;
    const { lanesModel } = (0, lanes_hooks_use_lanes_1.useLanes)();
    const currentLaneUrl = (lanesModel === null || lanesModel === void 0 ? void 0 : lanesModel.isViewingNonDefaultLane())
        ? // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
            `${lanes_ui_models_lanes_model_1.LanesModel.getLaneUrl(lanesModel.viewedLane.id)}${lanes_ui_models_lanes_model_1.LanesModel.baseLaneComponentRoute}`
        : '';
    const version = tag || hash;
    const author = (0, react_1.useMemo)(() => {
        return {
            displayName: username,
            email,
        };
    }, [snap]);
    const timestamp = (0, react_1.useMemo)(() => (date ? new Date(parseInt(date)).toString() : new Date().toString()), [date]);
    const location = (0, base_react_navigation_link_1.useLocation)();
    const { pathname } = location || {};
    const testsUrl = currentLaneUrl
        ? `${currentLaneUrl}/${componentId}/~tests?version=${version}`
        : `${pathname === null || pathname === void 0 ? void 0 : pathname.replace('~changelog', '~tests')}?version=${version}`;
    const compositionsUrl = currentLaneUrl
        ? `${currentLaneUrl}/${componentId}/~compositions?version=${version}`
        : `${pathname === null || pathname === void 0 ? void 0 : pathname.replace('~changelog', '~compositions')}?version=${version}`;
    const versionUrl = currentLaneUrl
        ? `${currentLaneUrl}/${componentId}?version=${version}`
        : `${pathname}?version=${version}`;
    return (react_1.default.createElement("div", { className: (0, classnames_1.default)(version_block_module_scss_1.default.versionWrapper, className) },
        react_1.default.createElement("div", { className: version_block_module_scss_1.default.left },
            react_1.default.createElement(component_ui_version_label_1.Labels, { isLatest: isLatest, isCurrent: isCurrent }),
            react_1.default.createElement(Link, { className: version_block_module_scss_1.default.link, href: testsUrl }, "Tests"),
            react_1.default.createElement(Link, { className: version_block_module_scss_1.default.link, href: compositionsUrl }, "Compositions"),
            react_1.default.createElement("div", { className: version_block_module_scss_1.default.placeholder })),
        react_1.default.createElement("div", Object.assign({ className: (0, classnames_1.default)(version_block_module_scss_1.default.right, className) }, rest),
            react_1.default.createElement(design_ui_tooltip_1.Tooltip, { placement: "right", content: hash },
                react_1.default.createElement(Link, { className: version_block_module_scss_1.default.titleLink, href: versionUrl },
                    react_1.default.createElement(documenter_ui_heading_1.H3, { size: "xs", className: version_block_module_scss_1.default.versionTitle }, tag ? `v${tag}` : hash))),
            react_1.default.createElement(design_ui_contributors_1.Contributors, { contributors: [author || {}], timestamp: timestamp }),
            commitMessage(message))));
}
function commitMessage(message) {
    if (!message || message === '')
        return react_1.default.createElement("div", { className: version_block_module_scss_1.default.emptyMessage }, "No commit message");
    return react_1.default.createElement("div", { className: version_block_module_scss_1.default.commitMessage }, message);
}
//# sourceMappingURL=version-block.js.map